hdu2844

题目链接:

点击打开链接

题目:

Whuacmers use coins.They have coins of value A1,A2,A3...An Silverland dollar. One day Hibix opened purse and found there were some coins. He decided to buy a very nice watch in a nearby shop. He wanted to pay the exact price(without change) and he known the
price would not more than m.But he didn‘t know the exact price of the watch.

You are to write a program which reads n,m,A1,A2,A3...An and C1,C2,C3...Cn corresponding to the number of Tony‘s coins of value A1,A2,A3...An then calculate how many prices(form 1 to m) Tony can pay use these coins.

Input

The input contains several test cases. The first line of each test case contains two integers n(1 ≤ n ≤ 100),m(m ≤ 100000).The second line contains 2n integers, denoting A1,A2,A3...An,C1,C2,C3...Cn (1 ≤ Ai ≤ 100000,1 ≤ Ci ≤ 1000). The last test case is followed
by two zeros.

Output

For each test case output the answer on a single line.

Sample Input

3 10
1 2 4 2 1 1
2 5
1 4 2 1
0 0

Sample Output

8
4

Source

2009 Multi-University
Training Contest 3 - Host by WHU

Recommend

gaojie

背包模板果然好用。。。

是一个多重背包转换成二进制背包的典型例子。。。

就是相当于1——m的背包能否装满。。。。即价值为i。。。

代码如下:

#include<cstring>
#include<cstdio>
#include<algorithm>
#include<iostream>
using namespace std;
const int maxn=100000+10;
int dp[maxn],v[105],Count[105],m;
void zeroonepack(int cost,int value)
{
    for(int i=m;i>=cost;i--)
        dp[i]=max(dp[i],dp[i-cost]+value);
}

void completepack(int cost,int value)
{
    for(int i=cost;i<=m;i++)
        dp[i]=max(dp[i],dp[i-cost]+value);
}

void multiplepack(int cost,int value,int amount)
{
    int k=1;
    if(cost*amount>=m)
        completepack(cost,value);
    else
    {
        while(k<amount)
        {
            zeroonepack(k*cost,k*value);
            amount-=k;
            k*=2;
        }
        zeroonepack(amount*cost,amount*value);
    }
}

int main()
{
    int i,j,n,min_count;
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        memset(dp,0,sizeof(dp));
        min_count=0;
        if(n==0&&m==0) return 0;
        for(i=1;i<=n;i++)
            scanf("%d",&v[i]);
        for(i=1;i<=n;i++)
            scanf("%d",&Count[i]);
        for(i=1;i<=n;i++)
        {
            multiplepack(v[i],v[i],Count[i]);
        }
        for(i=1;i<=m;i++)
        {
            if(dp[i]==i)
                min_count++;
        }
        printf("%d\n",min_count);

    }
    return 0;

hdu2844

时间: 2024-10-09 18:09:20

hdu2844的相关文章

hdu2844 &amp; poj1742 Coin ---多重背包--两种方法

题意:你有N种硬币,每种价值A[i],每种数量C[i],问.在不超过M的情况下,我们用这些硬币,付款有多少种情况.也就是:1,2,3,4,5,....,M这么多种情况下,你能用你的硬币不找钱,付款多少种情况. 例如: 你有一种硬币,价值2,个数2,那么 你是不能付款 3元的..你只能付款2,或者4元.. OK,题意差不多就是这样啦. 那么这里有两种方式! 分析: 那么这里我们可以用多重背包来解决,我们把价值和重量看成一样的w[i] = A[i]:用M作为背包.那么dp 过后,我们就可以知道 dp

【背包专题】 D - Coins hdu2844【多重背包】

Whuacmers use coins.They have coins of value A1,A2,A3...An Silverland dollar. One day Hibix opened purse and found there were some coins. He decided to buy a very nice watch in a nearby shop. He wanted to pay the exact price(without change) and he kn

hdu2844 coins 多重背包

1 #include<stdio.h> 2 #include<string.h> 3 int a[102],c[102],dp[100005]; 4 int max(int a,int b) 5 { 6 return a>b?a:b; 7 } 8 void CompletePack(int v,int w,int m) //完全背包 9 { 10 for(int j=v;j<=m;j++) 11 dp[j]=max(dp[j],dp[j-v]+w); 12 } 13 v

hdu2844(多重背包)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2844 题意:一位同学想要买手表,他有n种硬币,每种硬币已知有num[i]个.已知手表的价钱最多m元,问她用这些钱能够凑出多少种价格来买手表. 分析:二进制优化的多重背包,假设每种硬币为容量为val[i]且价值也为val[i]的物品,最后有dp[i]==i则能组成价格为i.因为容量为i能达到的最大价值也是i,刚好符合01背包的含义. #include <cstdio> #include <cs

hdu2844 多重背包模板

01 背包 有n 种不同的物品,每个物品有两个属性,size 体积,value 价值,现在给一个容量为 w 的背包,问最多可带走多少价值的物品. int f[w+1]; //f[x] 表示背包容量为x 时的最大价值 for (int i=0; i<n; i++) for (int j=w; j>=size[i]; j--) f[j] = max(f[j], f[j-size[i]]+value[i]); //逆序 完全背包 如果物品不计件数,就是每个物品有无数件的话,稍微改下即可 for (i

假期训练六(poj-1753,递归+hdu-2844,多重背包)

题目一:传送门 题意:有一个4*4的棋盘,每次翻转一个棋子和它的上下左右的四个棋子,判断翻转多少次之后可以变为纯色的棋盘. 思路:总共有C(0,16)+C(1,16)+C(2,16)+--+C(16,16)=2^16次,所以最多有16个棋子被翻动,然后从(0,0)个棋子开始,依次翻转其他棋子, 判断最少要翻转多少个棋子,记着要回溯. #include<iostream> #include<cstdio> #include<cstring> using namespace

hdu2844 Coins

hdu 二进制优化多重背包 将硬币的价值看做费用,使用的硬币个数看做价值,将第\(i\)种硬币看成\(c_i\)个价值为\(a_i\)的硬币跑01背包的话时间是\(O(m\sum c)\)的,显然不大行 注意到可以对\(c_i\)直接进行二进制拆分,把它拆成\(log\)个物品(\(2^0,2^1,\cdots,2^k,c_i-2^k(2^{k+1}>c_i)\)),再跑01背包时间就是\(O(m\sum log\ c_i)\)的,可以接受 #include<iostream> #inc

多重背包问题(来源:背包九讲)

问题: 有N种物品和一个容量为V的背包.第i种物品最多有n[i]件可用,每件费用是c[i],价值是w[i].求解将哪些物品装入背包可使这些物品的费用总和不超过背包容量,且价值总和最大. 基本算法: 这题目和全然背包问题非常类似.主要的方程仅仅需将全然背包问题的方程稍微一改就可以,由于对于第i种物品有n[i]+1种策略:取0件,取1件--取n[i]件.令f[i][v]表示前i种物品恰放入一个容量为v的背包的最大权值,则有状态转移方程:f[i][v]=max{f[i-1][v-k*c[i]]+k*w